#!/usr/bin/perl
-$debug = 0;
system("mkdir -p NEW DIFF");
-if(@ARGV == 1) {
- open(TESTLIST, "TESTLIST") || die "can not open TESTLIST: $!\n";
- $wanted = $ARGV[0];
- #print "Searching for test case $wanted\n";
- while(<TESTLIST>) {
- #print "Processing $_\n";
- next unless (/^$wanted/);
+if(@ARGV != 4) {
+ print "Usage: TESTonce name input output options\n";
+ exit 20;
+}
- chop;
- ($name,$input,$output,$options)=split(/\s+/,$_, 4);
- last;
- }
- close(TESTLIST);
+$name=$ARGV[0];
+$input=$ARGV[1];
+$output=$ARGV[2];
+$options=$ARGV[3];
- die "Can not find test $wanted\n" unless defined($input);
+$r = system "../tcpdump 2>/dev/null -n -r $input $options | tee NEW/$output | diff -uw $output - >DIFF/$output.diff";
-} elsif(@ARGV == 4) {
- $name=$ARGV[0];
- $input=$ARGV[1];
- $output=$ARGV[2];
- $options=$ARGV[3];
-} else {
- print "Usage: TESTonce name [input output options]\n";
- exit 20;
+if($r == 0) {
+ printf "%-30s: passed\n", $name;
+ unlink "DIFF/$output.diff";
+ exit 0;
}
+printf "%-30s: TEST FAILED", $name;
+open FOUT, '>>failure-outputs.txt';
+printf FOUT "Failed test: $name\n\n";
+close FOUT;
+system "cat DIFF/$output.diff >> failure-outputs.txt";
-print "Running $name. \n" if $debug;
-print " Input: $input, OUTPUT: $output, OPTIONS: $options\n" if $debug;
-
-print " ";
-exec("../tcpdump 2>/dev/null -n -r $input $options | tee NEW/$output | diff -w - $output >DIFF/$output.diff");
-@cores = glob("core*");
-exit 10 if (@cores > 0);
-exit 0;
+if($r == -1) {
+ print " (failed to execute: $!)\n";
+ exit 30;
+}
+if($r & 127) {
+ printf " (terminated with signal %u, %s coredump)\n", ($r & 127), ($r & 128) ? 'with' : 'without';
+ exit ($r & 128) ? 10 : 20;
+}
+print "\n";
+exit $r >> 8;
mkdir -p DIFF
passed=0
failed=0
+INDENT=' '
cat /dev/null > failure-outputs.txt
-# first run any specific tests.
-for i in *.sh
-do
- case $i in TEST*.sh) continue;; esac
-
- if sh ./$i >DIFF/$i.result
- then
- echo $i: passed.
- rm -f DIFF/$i.result
+runComplexTests()
+{
+ for i in *.sh
+ do
+ case $i in TEST*.sh) continue;; esac
+ echo -n "$INDENT"
+ if sh ./$i
+ then
passed=`expr $passed + 1`
- else
- echo $i: failed.
+ else
failed=`expr $failed + 1`
- fi
-done
-
-echo $passed >.passed
-echo $failed >.failed
+ fi
+ done
+}
-# now run typical tests
-cat TESTLIST | while read name input output options
-do
- case $name in
+runSimpleTests()
+{
+ local only=$1
+ echo $passed >.passed
+ echo $failed >.failed
+ cat TESTLIST | while read name input output options
+ do
+ case $name in
\#*) continue;;
'') continue;;
- esac
-
- if ./TESTonce $name $input $output "$options"
- then
- echo $name: passed.
- rm -f DIFF/$output.diff
+ esac
+ [ "$only" != "" -a "$name" != "$only" ] && continue
+ echo -n "$INDENT"
+ if ./TESTonce $name $input $output "$options"
+ then
passed=`expr $passed + 1`
echo $passed >.passed
- else
- echo $name: failed.
+ else
failed=`expr $failed + 1`
echo $failed >.failed
- echo "Failed test: $name" >> failure-outputs.txt
- echo >> failure-outputs.txt
- cat DIFF/$output.diff >> failure-outputs.txt
- echo >> failure-outputs.txt
- fi
-done
+ fi
+ [ "$only" != "" -a "$name" == "$only" ] && break
+ done
+ # I hate shells with their stupid, useless subshells.
+ passed=`cat .passed`
+ failed=`cat .failed`
+}
-# I hate shells with their stupid, useless subshells.
-passed=`cat .passed`
-failed=`cat .failed`
+if [ $# -eq 0 ]
+then
+ runComplexTests
+ runSimpleTests
+elif [ $# -eq 1 ]
+then
+ runSimpleTests $1
+else
+ echo "Usage: $0 [test_name]"
+ exit 30
+fi
# exit with number of failing tests.
-echo
-echo
+echo '------------------------------------------------'
printf "%4u tests failed\n" $failed
printf "%4u tests passed\n" $passed
echo
cat failure-outputs.txt
echo
echo
-exit $failed
-
-
-
-
+exit $failed